#include <bits/stdc++.h>

using namespace std;


int ans[1000*1000];
int predans[1000*1000];
int mas[1000][1000];
char masx[1000][1000];
bool usd[1000][1000];
int n, m, g, tec;

int dfs(int x, int y) {
    //cout << x <<  ' ' << y << ' ' << masx[x][y] << endl;
    if(usd[x][y]) {
           // cout << "OK";
        usd[x][y] = false;
        return tec;
    }
    //if(mas[x][y] == tec) return tec;
    if(mas[x][y] != 0) return mas[x][y] + (mas[x][y]>1234567?0:1234567);
    usd[x][y] = true;
    //int &k = mas[x][y];
    switch(masx[x][y]) {
    case 'W':
    case 'w':
        mas[x][y] = dfs(x-1, y);
        break;
    case 'N':
    case 'n':
        mas[x][y] = dfs(x, y-1);
        break;
    case 'E':
    case 'e':
        mas[x][y] = dfs(x+1, y);
        break;
    case 'S':
    case 's':
        mas[x][y] = dfs(x, y+1);
    }

    if(!usd[x][y]) return mas[x][y] + 1234567;
    usd[x][y] =false;
    return mas[x][y];
}



int main() {
    freopen("robots.in", "r", stdin);
    freopen("robots.out", "w", stdout);
    char c;
    scanf("%d%d%d\n", &n, &m, &g);
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            scanf("%c", &c);
            if(c == '\n') {
                j--;
                continue;
            }
            masx[j][i] = c;
        }
        //scanf("\n");
    }
    tec = 1;
    int k;
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < m; j++) {
            if(mas[j][i] == 0 && dfs(j, i)%1234567 == tec) tec++;
        }
    }
    for(int i = 0; i < m; i++) {
        for(int j = 0; j < n; j++) {
            if(mas[i][j] < 1234567) predans[mas[i][j]]++;
            if(isupper(masx[i][j])) ans[mas[i][j]%1234567]++;
        }
    }
   // for(int i = 0; i < n; i++) {
       // for(int j = 0; j < m; j++) {
           // cout << mas[i][j] << ' ';
        //}
       //cout << endl;
   // }
    int anns = 0;
    //for(int i = 0; i < 10; i++) cout << ans[i] << ' ' << predans[i] << endl;
    for(int i = 0; i < 1000*1000; i++) anns += min(predans[i], ans[i]);
    printf("%d", anns);
    return 0;
}

/*
3 4 0
SSSS
EESW
ENWW

*/
